/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.readers.medreaders.ReadDICOM;

import com.pixelmed.dicom.Attribute;
import com.pixelmed.dicom.AttributeList;
import com.pixelmed.dicom.AttributeTree;
import com.pixelmed.dicom.DicomDirectoryRecord;
import com.pixelmed.dicom.DicomException;
import com.pixelmed.dicom.TagFromName;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 *
 * @author babor
 */
public class DICOMStudyInfoPanel extends javax.swing.JPanel
{

    private SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
    private DicomDirectoryRecord ddr = null;
    private DicomInfoFrame infoFrame;

    /**
     * Creates new form DICOMPatientInfoPanel
     */
    public DICOMStudyInfoPanel(DicomInfoFrame infoFrame)
    {
        this.infoFrame = infoFrame;
        initComponents();
    }

    public void setDicomDirectoryRecord(DicomDirectoryRecord ddr)
    {
        this.ddr = ddr;
        try {
            infoFrame.setTreeModel(new AttributeTree(ddr.getAttributeList()));
        } catch (DicomException ex) {
            infoFrame.setTreeModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
        }

        AttributeList atl = ddr.getAttributeList();
        Attribute att;

        Date studyDate = null;
        att = atl.get(TagFromName.StudyDate);
        if (att != null) {
            SimpleDateFormat parseDF = new SimpleDateFormat("yyyyMMdd");
            String tmp = att.getSingleStringValueOrEmptyString();
            if (tmp != null && tmp.length() > 0) {
                try {
                    studyDate = parseDF.parse(tmp);
                } catch (ParseException ex) {
                    studyDate = null;
                }
            }
        }

        String studyDescription = "<n/a>";
        att = atl.get(TagFromName.StudyDescription);
        if (att != null) {
            studyDescription = att.getSingleStringValueOrDefault("<n/a>");
        }

        setStudyData(studyDate, studyDescription, ddr.getChildCount());
    }

    private void setStudyData(Date studyDate, String studyDescription, int nSeries)
    {
        if (studyDate != null)
            studyDateLabel.setText(df.format(studyDate));
        else
            studyDateLabel.setText("<n/a>");
        studyDescriptionLabel.setText(studyDescription);
        seriesLabel.setText("" + nSeries);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        studyDescriptionLabel = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        seriesLabel = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        studyDateLabel = new javax.swing.JLabel();
        infoButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("Entry type:  STUDY");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(35, 10, 10, 10);
        add(jLabel1, gridBagConstraints);

        studyDescriptionLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        studyDescriptionLabel.setText("<n/a>");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 0);
        add(studyDescriptionLabel, gridBagConstraints);

        jLabel3.setText("Study description:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 0);
        add(jLabel3, gridBagConstraints);

        jLabel9.setText("No. of series:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 5, 0);
        add(jLabel9, gridBagConstraints);

        seriesLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        seriesLabel.setText("<n/a>");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 5, 0);
        add(seriesLabel, gridBagConstraints);

        jLabel4.setText("Study date:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 0);
        add(jLabel4, gridBagConstraints);

        studyDateLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        studyDateLabel.setText("<n/a>");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 0);
        add(studyDateLabel, gridBagConstraints);

        infoButton.setText("Show full info");
        infoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                infoButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(35, 5, 5, 10);
        add(infoButton, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void infoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_infoButtonActionPerformed
        JFrame frame = (JFrame) SwingUtilities.getRoot(this);
        infoFrame.setLocation(frame.getLocation().x + frame.getWidth(), frame.getLocation().y);
        infoFrame.setVisible(true);
    }//GEN-LAST:event_infoButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton infoButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel seriesLabel;
    private javax.swing.JLabel studyDateLabel;
    private javax.swing.JLabel studyDescriptionLabel;
    // End of variables declaration//GEN-END:variables

}
